/* Prototypes for functions defined in
editfns.c
 */

extern int Vsystem_name;

extern int Vuser_real_name;

extern int Vuser_full_name;

extern int Vuser_name;

void init_editfns(void);

extern struct Lisp_Subr Schar_to_string;

int Fchar_to_string(int );

extern struct Lisp_Subr Sstring_to_char;

int Fstring_to_char(int );

int buildmark(int val);

extern struct Lisp_Subr Spoint;

int Fpoint(void);

extern struct Lisp_Subr Spoint_marker;

int Fpoint_marker(void);

int clip_to_bounds(int lower,
                   int num,
                   int upper);

extern struct Lisp_Subr Sgoto_char;

int Fgoto_char(int );

int region_limit(int beginningp);

extern struct Lisp_Subr Sregion_beginning;

int Fregion_beginning(void);

extern struct Lisp_Subr Sregion_end;

int Fregion_end(void);

extern struct Lisp_Subr Smark_marker;

int Fmark_marker(void);

int save_excursion_save(void);

int save_excursion_restore(register int info);

extern struct Lisp_Subr Ssave_excursion;

int Fsave_excursion(int );

extern struct Lisp_Subr Sbufsize;

int Fbufsize(void);

extern struct Lisp_Subr Spoint_min;

int Fpoint_min(void);

extern struct Lisp_Subr Spoint_min_marker;

int Fpoint_min_marker(void);

extern struct Lisp_Subr Spoint_max;

int Fpoint_max(void);

extern struct Lisp_Subr Spoint_max_marker;

int Fpoint_max_marker(void);

extern struct Lisp_Subr Sfollowing_char;

int Ffollowing_char(void);

extern struct Lisp_Subr Sprevious_char;

int Fprevious_char(void);

extern struct Lisp_Subr Sbobp;

int Fbobp(void);

extern struct Lisp_Subr Seobp;

int Feobp(void);

extern struct Lisp_Subr Sbolp;

int Fbolp(void);

extern struct Lisp_Subr Seolp;

int Feolp(void);

extern struct Lisp_Subr Schar_after;

int Fchar_after(int );

extern struct Lisp_Subr Suser_login_name;

int Fuser_login_name(void);

extern struct Lisp_Subr Suser_real_login_name;

int Fuser_real_login_name(void);

extern struct Lisp_Subr Suser_uid;

int Fuser_uid(void);

extern struct Lisp_Subr Suser_real_uid;

int Fuser_real_uid(void);

extern struct Lisp_Subr Suser_full_name;

int Fuser_full_name(void);

extern struct Lisp_Subr Ssystem_name;

int Fsystem_name(void);

extern struct Lisp_Subr Semacs_pid;

int Femacs_pid(void);

extern struct Lisp_Subr Scurrent_time;

int Fcurrent_time(void);

int lisp_time_argument(int specified_time,
                       long * result);

extern struct Lisp_Subr Scurrent_time_string;

int Fcurrent_time_string(int );

long difftm(struct tm * a,
            struct tm * b);

extern struct Lisp_Subr Scurrent_time_zone;

int Fcurrent_time_zone(int );

void insert1(int arg);

extern struct Lisp_Subr Sinsert;

int Finsert(int , int * );

extern struct Lisp_Subr Sinsert_and_inherit;

int Finsert_and_inherit(int , int * );

extern struct Lisp_Subr Sinsert_before_markers;

int Finsert_before_markers(int , int * );

extern struct Lisp_Subr Sinsert_and_inherit_before_marke;

int Finsert_and_inherit_before_marke(int , int * );

extern struct Lisp_Subr Sinsert_char;

int Finsert_char(int , int );

int make_buffer_string(int start,
                       int end);

extern struct Lisp_Subr Sbuffer_substring;

int Fbuffer_substring(int , int );

extern struct Lisp_Subr Sbuffer_string;

int Fbuffer_string(void);

extern struct Lisp_Subr Sinsert_buffer_substring;

int Finsert_buffer_substring(int , int , int );

extern struct Lisp_Subr Scompare_buffer_substrings;

int Fcompare_buffer_substrings(int , int , int , int , int , int );

extern struct Lisp_Subr Ssubst_char_in_region;

int Fsubst_char_in_region(int , int , int , int , int );

extern struct Lisp_Subr Stranslate_region;

int Ftranslate_region(int , int , int );

extern struct Lisp_Subr Sdelete_region;

int Fdelete_region(int , int );

extern struct Lisp_Subr Swiden;

int Fwiden(void);

extern struct Lisp_Subr Snarrow_to_region;

int Fnarrow_to_region(int , int );

int save_restriction_save(void);

int save_restriction_restore(int data);

extern struct Lisp_Subr Ssave_restriction;

int Fsave_restriction(int );

extern char * message_text;

extern int message_length;

extern struct Lisp_Subr Smessage;

int Fmessage(int , int * );

extern struct Lisp_Subr Sformat;

int Fformat(int , int * );

int format1(char * string1, ...);

extern struct Lisp_Subr Schar_equal;

int Fchar_equal(int , int );

void transpose_markers(register int start1,
                       register int end1,
                       register int start2,
                       register int end2);

extern struct Lisp_Subr Stranspose_regions;

int Ftranspose_regions(int , int , int , int , int );

void syms_of_editfns(void);

