/* Prototypes for functions defined in
minibuf.c
 */

extern int Vminibuffer_list;

extern int minibuf_save_vector_size;

extern struct minibuf_save_data * minibuf_save_vector;

extern int minibuf_level;

extern int auto_help;

extern int last_minibuf_string;

extern int enable_recursive_minibuffers;

extern int Vminibuffer_help_form;

extern int Vminibuffer_history_variable;

extern int Vminibuffer_history_position;

extern int Qminibuffer_history;

extern int Qread_file_name_internal;

extern int Qminibuffer_setup_hook;

extern int Vminibuffer_setup_hook;

extern int Qminibuffer_exit_hook;

extern int Vminibuffer_exit_hook;

extern int completion_ignore_case;

extern int Vcompletion_regexp_list;

extern int minibuffer_auto_raise;

extern int last_exact_completion;

extern int Quser_variable_p;

int read_minibuf(int map,
                 int initial,
                 int prompt,
                 int backup_n,
                 int expflag,
                 int histvar,
                 int histpos);

int get_minibuffer(int depth);

void read_minibuf_unwind(int data);

extern struct Lisp_Subr Sread_from_minibuffer;

int Fread_from_minibuffer(int , int , int , int , int );

extern struct Lisp_Subr Sread_minibuffer;

int Fread_minibuffer(int , int );

extern struct Lisp_Subr Seval_minibuffer;

int Feval_minibuffer(int , int );

extern struct Lisp_Subr Sread_string;

int Fread_string(int , int );

extern struct Lisp_Subr Sread_no_blanks_input;

int Fread_no_blanks_input(int , int );

extern struct Lisp_Subr Sread_command;

int Fread_command(int );

extern struct Lisp_Subr Sread_variable;

int Fread_variable(int );

extern struct Lisp_Subr Sread_buffer;

int Fread_buffer(int , int , int );

extern struct Lisp_Subr Stry_completion;

int Ftry_completion(int , int , int );

int scmp(register char * s1,
         register char * s2,
         int len);

extern struct Lisp_Subr Sall_completions;

int Fall_completions(int , int , int );

extern int Vminibuffer_completion_table;

extern int Qminibuffer_completion_table;

extern int Vminibuffer_completion_predicate;

extern int Qminibuffer_completion_predicate;

extern int Vminibuffer_completion_confirm;

extern int Qminibuffer_completion_confirm;

extern struct Lisp_Subr Scompleting_read;

int Fcompleting_read(int , int , int , int , int , int );

int temp_echo_area_glyphs(char * m);

int do_completion(void);

int assoc_for_completion(register int key,
                         int list);

extern struct Lisp_Subr Sminibuffer_complete;

int Fminibuffer_complete(void);

extern struct Lisp_Subr Sminibuffer_complete_and_exit;

int Fminibuffer_complete_and_exit(void);

extern struct Lisp_Subr Sminibuffer_complete_word;

int Fminibuffer_complete_word(void);

extern struct Lisp_Subr Sdisplay_completion_list;

int Fdisplay_completion_list(int );

extern struct Lisp_Subr Sminibuffer_completion_help;

int Fminibuffer_completion_help(void);

extern struct Lisp_Subr Sself_insert_and_exit;

int Fself_insert_and_exit(void);

extern struct Lisp_Subr Sexit_minibuffer;

int Fexit_minibuffer(void);

extern struct Lisp_Subr Sminibuffer_depth;

int Fminibuffer_depth(void);

extern struct Lisp_Subr Sminibuffer_prompt;

int Fminibuffer_prompt(void);

extern struct Lisp_Subr Sminibuffer_prompt_width;

int Fminibuffer_prompt_width(void);

int init_minibuf_once(void);

int syms_of_minibuf(void);

int keys_of_minibuf(void);

